#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"
#include "vidInfo.h"
#include "particle.h"
#include "vectorField.h"
#include "spring.h"


class testApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed  (int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
	
	ofTexture myTexture;
	
	vidInfo liveVidInfo;
	bool bInfoGrabbed;
	bool bTriggered;
	bool bAppView;
	
	vector <particle *> particles;
	vector <spring> springs;
	vectorField VF;
	
	float prevMouseX;
	float prevMouseY;
	
	int howManyParticlesX;
	int howManyParticlesY;
	int redValues[80*60];
	int greenValues[80*60];
	int blueValues[80*60];

};

#endif
